# remirepo/Fedora spec file for php-zendframework-zend-view
#
# Copyright (c) 2015-2018 Remi Collet
# License: CC-BY-SA
# http://creativecommons.org/licenses/by-sa/4.0/
#
# Please, preserve the changelog entries
#
%global bootstrap    0
%global gh_commit    0428d6b2a67c7058451394921c90c5576ac5b373
%global gh_short     %(c=%{gh_commit}; echo ${c:0:7})
%global gh_owner     zendframework
%global gh_project   zend-view
%global php_home     %{_datadir}/php
%global library      View
%if %{bootstrap}
%global with_tests   0%{?_with_tests:1}
%else
%global with_tests   0%{!?_without_tests:1}
%endif

Name:           php-%{gh_owner}-%{gh_project}
Version:        2.11.1
Release:        1%{?dist}
Summary:        Zend Framework %{library} component

Group:          Development/Libraries
License:        BSD
URL:            https://zendframework.github.io/%{gh_project}/
Source0:        %{gh_commit}/%{name}-%{version}-%{gh_short}.tgz
Source1:        makesrc.sh

BuildArch:      noarch
# Tests
%if %{with_tests}
BuildRequires:  php(language) >= 5.6
BuildRequires:  php-date
BuildRequires:  php-dom
BuildRequires:  php-filter
BuildRequires:  php-pcre
BuildRequires:  php-spl
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2 with php-autoloader(%{gh_owner}/zend-eventmanager)   < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1 with php-autoloader(%{gh_owner}/zend-json)           < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-loader)         >= 2.5   with php-autoloader(%{gh_owner}/zend-loader)         < 3)
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7   with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
# remirepo:6
%else
BuildRequires:  php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1
BuildRequires:  php-autoloader(%{gh_owner}/zend-loader)         >= 2.5
BuildRequires:  php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.5
%endif
# From composer, "require-dev": {
#        "phpunit/phpunit": "^5.7.15 || ^6.0.8",
#        "zendframework/zend-authentication": "^2.5",
#        "zendframework/zend-cache": "^2.6.1",
#        "zendframework/zend-coding-standard": "~1.0.0",
#        "zendframework/zend-config": "^2.6",
#        "zendframework/zend-console": "^2.6",
#        "zendframework/zend-escaper": "^2.5",
#        "zendframework/zend-feed": "^2.7",
#        "zendframework/zend-filter": "^2.6.1",
#        "zendframework/zend-http": "^2.5.4",
#        "zendframework/zend-i18n": "^2.6",
#        "zendframework/zend-log": "^2.7",
#        "zendframework/zend-modulemanager": "^2.7.1",
#        "zendframework/zend-mvc": "^2.7.14 || ^3.0",
#        "zendframework/zend-navigation": "^2.5",
#        "zendframework/zend-paginator": "^2.5",
#        "zendframework/zend-permissions-acl": "^2.6",
#        "zendframework/zend-router": "^3.0.1",
#        "zendframework/zend-serializer": "^2.6.1",
#        "zendframework/zend-servicemanager": "^2.7.5 || ^3.0.3",
#        "zendframework/zend-session": "^2.8.1",
#        "zendframework/zend-uri": "^2.5"
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
BuildRequires: (php-composer(%{gh_owner}/zend-authentication)   >= 2.5    with php-composer(%{gh_owner}/zend-authentication)   < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-cache)            >= 2.6.1  with php-composer(%{gh_owner}/zend-cache)            < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-config)           >= 2.6    with php-composer(%{gh_owner}/zend-config)           < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-console)          >= 2.6    with php-composer(%{gh_owner}/zend-console)          < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-escaper)          >= 2.5    with php-composer(%{gh_owner}/zend-escaper)          < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-feed)             >= 2.7    with php-composer(%{gh_owner}/zend-feed)             < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-filter)           >= 2.6.1  with php-composer(%{gh_owner}/zend-filter)           < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-http)             >= 2.5.4  with php-composer(%{gh_owner}/zend-http)             < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-i18n)             >= 2.6    with php-composer(%{gh_owner}/zend-i18n)             < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-log)              >= 2.7    with php-composer(%{gh_owner}/zend-log)              < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-modulemanager)    >= 2.7.1  with php-composer(%{gh_owner}/zend-modulemanager)    < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-mvc)              >= 2.7.14 with php-composer(%{gh_owner}/zend-mvc)              < 4)
BuildRequires: (php-composer(%{gh_owner}/zend-navigation)       >= 2.5    with php-composer(%{gh_owner}/zend-navigation)       < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-paginator)        >= 2.5    with php-composer(%{gh_owner}/zend-paginator)        < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-permissions-acl)  >= 2.6    with php-composer(%{gh_owner}/zend-permissions-acl)  < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-router)           >= 3.0.1  with php-composer(%{gh_owner}/zend-router)           < 4)
BuildRequires: (php-composer(%{gh_owner}/zend-serializer)       >= 2.6.1  with php-composer(%{gh_owner}/zend-serializer)       < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-servicemanager)   >= 2.7.5  with php-composer(%{gh_owner}/zend-servicemanager)   < 4)
BuildRequires: (php-composer(%{gh_owner}/zend-session)          >= 2.8.1  with php-composer(%{gh_owner}/zend-session)          < 3)
BuildRequires: (php-composer(%{gh_owner}/zend-uri)              >= 2.5    with php-composer(%{gh_owner}/zend-uri)              < 3)
# remirepo:22
%else
BuildRequires:  php-composer(%{gh_owner}/zend-authentication)   >= 2.5
BuildRequires:  php-composer(%{gh_owner}/zend-cache)            >= 2.6.1
BuildRequires:  php-composer(%{gh_owner}/zend-config)           >= 2.6
BuildRequires:  php-composer(%{gh_owner}/zend-console)          >= 2.6
BuildRequires:  php-composer(%{gh_owner}/zend-escaper)          >= 2.5
BuildRequires:  php-composer(%{gh_owner}/zend-feed)             >= 2.7
BuildRequires:  php-composer(%{gh_owner}/zend-filter)           >= 2.6.1
BuildRequires:  php-composer(%{gh_owner}/zend-http)             >= 2.5.4
BuildRequires:  php-composer(%{gh_owner}/zend-i18n)             >= 2.6
BuildRequires:  php-composer(%{gh_owner}/zend-log)              >= 2.7
BuildRequires:  php-composer(%{gh_owner}/zend-modulemanager)    >= 2.7.1
BuildRequires:  php-composer(%{gh_owner}/zend-mvc)              >= 2.7.14
BuildRequires:  php-composer(%{gh_owner}/zend-navigation)       >= 2.5
BuildRequires:  php-composer(%{gh_owner}/zend-paginator)        >= 2.5
BuildRequires:  php-composer(%{gh_owner}/zend-permissions-acl)  >= 2.6
BuildRequires:  php-composer(%{gh_owner}/zend-router)           >= 3.0.1
BuildRequires:  php-composer(%{gh_owner}/zend-serializer)       >= 2.6.1
BuildRequires:  php-composer(%{gh_owner}/zend-servicemanager)   >= 2.7.5
BuildRequires:  php-composer(%{gh_owner}/zend-session)          >= 2.8.1
BuildRequires:  php-composer(%{gh_owner}/zend-uri)              >= 2.5
%endif
BuildRequires:  phpunit6
# Not in composer.json
%if 0%{?fedora} >= 26 || 0%{?rhel} >= 8
BuildRequires:  php-composer(%{gh_owner}/zend-mvc-plugin-flashmessenger)
BuildRequires:  php-composer(%{gh_owner}/zend-mvc-i18n)
BuildRequires:  php-composer(%{gh_owner}/zend-mvc-console)
%endif
%endif
# Autoloader
BuildRequires:  php-fedora-autoloader-devel

# From composer, "require": {
#        "php": "^5.6 || ^7.0",
#        "zendframework/zend-eventmanager": "^2.6.2 || ^3.0",
#        "zendframework/zend-json": "^2.6.1 || ^3.0",
#        "zendframework/zend-loader": "^2.5",
#        "zendframework/zend-stdlib": "^2.7 || ^3.0"
Requires:       php(language) >= 5.6
%if ! %{bootstrap}
# remirepo:1
%if 0%{?fedora} >= 27 || 0%{?rhel} >= 8
Requires:      (php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2 with php-autoloader(%{gh_owner}/zend-eventmanager)   < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1 with php-autoloader(%{gh_owner}/zend-json)           < 4)
Requires:      (php-autoloader(%{gh_owner}/zend-loader)         >= 2.5   with php-autoloader(%{gh_owner}/zend-loader)         < 3)
Requires:      (php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7   with php-autoloader(%{gh_owner}/zend-stdlib)         < 4)
# remirepo:10
%else
Requires:       php-autoloader(%{gh_owner}/zend-eventmanager)   >= 2.6.2
Requires:       php-autoloader(%{gh_owner}/zend-eventmanager)   <  4
Requires:       php-autoloader(%{gh_owner}/zend-json)           <  4
Requires:       php-autoloader(%{gh_owner}/zend-json)           >= 2.6.1
Requires:       php-autoloader(%{gh_owner}/zend-loader)         >= 2.5
Requires:       php-autoloader(%{gh_owner}/zend-loader)         <  3
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         >= 2.7
Requires:       php-autoloader(%{gh_owner}/zend-stdlib)         <  4
%endif
# From composer, "suggest": {
#        "zendframework/zend-authentication": "Zend\\Authentication component",
#        "zendframework/zend-escaper": "Zend\\Escaper component",
#        "zendframework/zend-feed": "Zend\\Feed component",
#        "zendframework/zend-filter": "Zend\\Filter component",
#        "zendframework/zend-http": "Zend\\Http component",
#        "zendframework/zend-i18n": "Zend\\I18n component",
#        "zendframework/zend-mvc": "Zend\\Mvc component",
#        "zendframework/zend-mvc-plugin-flashmessenger": "zend-mvc-plugin-flashmessenger component, if you want to use the FlashMessenger view helper with zend-mvc versions 3 and up",
#        "zendframework/zend-navigation": "Zend\\Navigation component",
#        "zendframework/zend-paginator": "Zend\\Paginator component",
#        "zendframework/zend-permissions-acl": "Zend\\Permissions\\Acl component",
#        "zendframework/zend-servicemanager": "Zend\\ServiceManager component",
#        "zendframework/zend-uri": "Zend\\Uri component"
%if 0%{?fedora} >= 21 || 0%{?rhel} >= 8
Suggests:       php-composer(%{gh_owner}/zend-authentication)
Suggests:       php-composer(%{gh_owner}/zend-escaper)
Suggests:       php-composer(%{gh_owner}/zend-feed)
Suggests:       php-composer(%{gh_owner}/zend-filter)
Suggests:       php-composer(%{gh_owner}/zend-http)
Suggests:       php-composer(%{gh_owner}/zend-i18n)
Suggests:       php-composer(%{gh_owner}/zend-mvc)
Suggests:       php-composer(%{gh_owner}/zend-mvc-plugin-flashmessenger)
Suggests:       php-composer(%{gh_owner}/zend-navigation)
Suggests:       php-composer(%{gh_owner}/zend-paginator)
Suggests:       php-composer(%{gh_owner}/zend-permissions-acl)
Suggests:       php-composer(%{gh_owner}/zend-servicemanager)
Suggests:       php-composer(%{gh_owner}/zend-uri)
%endif
%endif
# Autoloader
Requires:       php-composer(fedora/autoloader)
# From phpcompatinfo report for version 2.6.0
Requires:       php-cli
Requires:       php-date
Requires:       php-dom
Requires:       php-filter
Requires:       php-pcre
Requires:       php-spl

Obsoletes:      php-ZendFramework2-%{library} < 2.5
Provides:       php-ZendFramework2-%{library} = %{version}
Provides:       php-composer(%{gh_owner}/%{gh_project}) = %{version}
Provides:       php-autoloader(%{gh_owner}/%{gh_project}) = %{version}
# for zf_templatemap_generator command
Conflicts:      php-zendframework < 2.5.3-3


%description
Zend\View provides the “View” layer of Zend Framework 2’s MVC system.
It is a multi-tiered system allowing a variety of mechanisms for extension,
substitution, and more.

Documentation: https://zendframework.github.io/%{gh_project}/


%prep
%setup -q -n %{gh_project}-%{gh_commit}

mv LICENSE.md LICENSE


%build
: Create autoloader
phpab --template fedora --output src/autoload.php src
cat << 'EOF' | tee -a src/autoload.php
\Fedora\Autoloader\Dependencies::required([
    '%{php_home}/Zend/EventManager/autoload.php',
    '%{php_home}/Zend/Loader/autoload.php',
    '%{php_home}/Zend/Stdlib/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Authentication/autoload.php',
    '%{php_home}/Zend/Escaper/autoload.php',
    '%{php_home}/Zend/Feed/autoload.php',
    '%{php_home}/Zend/Filter/autoload.php',
    '%{php_home}/Zend/Http/autoload.php',
    '%{php_home}/Zend/I18n/autoload.php',
    '%{php_home}/Zend/Json/autoload.php',
    '%{php_home}/Zend/Mvc/autoload.php',
    '%{php_home}/Zend/Navigation/autoload.php',
    '%{php_home}/Zend/Paginator/autoload.php',
    '%{php_home}/Zend/Permissions/Acl/autoload.php',
    '%{php_home}/Zend/ServiceManager/autoload.php',
    '%{php_home}/Zend/Uri/autoload.php',
]);
EOF


%install
mkdir -p   %{buildroot}%{php_home}/Zend/
cp -pr src %{buildroot}%{php_home}/Zend/%{library}

# From composer.json,     "bin": [
#        "bin/templatemap_generator.php"
for i in bin/templatemap_generator.php
do   install -Dpm 755 $i %{buildroot}%{_bindir}/zf_$(basename $i .php)
done


%check
%if %{with_tests}
# Ignore test which requires router v3
rm test/Helper/UrlTest.php

mkdir vendor
cat << 'EOF' | tee vendor/autoload.php
<?php
require_once '%{buildroot}%{php_home}/Zend/%{library}/autoload.php';
# For BR without new autoloader
\Fedora\Autoloader\Dependencies::optional([
    '%{php_home}/Zend/Cache/autoload.php',
    '%{php_home}/Zend/Config/autoload.php',
    '%{php_home}/Zend/Console/autoload.php',
    '%{php_home}/Zend/Log/autoload.php',
    '%{php_home}/Zend/ModuleManager/autoload.php',
    '%{php_home}/Zend/Router/autoload.php',
    '%{php_home}/Zend/Serializer/autoload.php',
    '%{php_home}/Zend/Session/autoload.php',
    '%{php_home}/Zend/autoload.php',
]);
\Fedora\Autoloader\Dependencies::optional([
    dirname(__DIR__) . '/test/autoload.php',
]);
\Fedora\Autoloader\Autoload::addPsr4('ZendTest\\%{library}\\', dirname(__DIR__) . '/test');
EOF

ret=0
for cmd in php php70 php71 php72 php73; do
  if which $cmd; then
    $cmd %{_bindir}/phpunit6 --verbose || ret=1
  fi
done
exit $ret
%else
: Test suite disabled
%endif


%files
%{!?_licensedir:%global license %%doc}
%license LICENSE
%doc *.md
%doc composer.json
%{php_home}/Zend/%{library}
%{_bindir}/zf_templatemap_generator


%changelog
* Tue Dec 11 2018 Remi Collet <remi@remirepo.net> - 2.11.1-1
- update to 2.11.1
- add mandatory dependency on zendframework/zend-json
- add optional dependency on zendframework/zend-mvc-plugin-flashmessenger
- raise dependency on zendframework/zend-mvc 2.7.14
- use range dependencies

* Thu Dec  6 2018 Remi Collet <remi@remirepo.net> - 2.10.0-4
- cleanup for EL-8

* Thu Jan 18 2018 Remi Collet <remi@remirepo.net> - 2.10.0-1
- Update to 2.10.0
- only use phpunit6

* Tue Dec 12 2017 Remi Collet <remi@remirepo.net> - 2.9.0-3
- switch from zend-loader to fedora/autoloader

* Tue Mar 21 2017 Remi Collet <remi@remirepo.net> - 2.9.0-1
- Update to 2.9.0
- raise dependency on PHP 5.6
- use phpunit6 on F26+

* Tue Mar 21 2017 Remi Collet <remi@remirepo.net> - 2.8.2-1
- Update to 2.8.2

* Tue Feb 21 2017 Remi Collet <remi@fedoraproject.org> - 2.8.1-2
- add missing BR, fix FTBFS #1424088

* Fri Jul  1 2016 Remi Collet <remi@fedoraproject.org> - 2.8.1-1
- version 2.8.1

* Wed Jun 22 2016 Remi Collet <remi@fedoraproject.org> - 2.8.0-1
- version 2.8.0
- add zf_templatemap_generator (dropped from zf2)

* Thu May 12 2016 Remi Collet <remi@fedoraproject.org> - 2.7.0-1
- version 2.7.0

* Tue Apr 19 2016 Remi Collet <remi@fedoraproject.org> - 2.6.7-1
- version 2.6.7

* Mon Mar 21 2016 Remi Collet <remi@fedoraproject.org> - 2.6.5-1
- version 2.6.5

* Mon Mar 21 2016 Remi Collet <remi@fedoraproject.org> - 2.6.4-2
- add patch for zend-navigation issue, see:
  https://github.com/zendframework/zend-navigation/issues/23

* Thu Mar  3 2016 Remi Collet <remi@fedoraproject.org> - 2.6.4-1
- version 2.6.4

* Tue Feb 23 2016 Remi Collet <remi@fedoraproject.org> - 2.6.3-1
- version 2.6.3

* Fri Feb 19 2016 Remi Collet <remi@fedoraproject.org> - 2.6.2-1
- version 2.6.2

* Thu Feb 18 2016 Remi Collet <remi@fedoraproject.org> - 2.6.1-1
- version 2.6.1

* Thu Feb 18 2016 Remi Collet <remi@fedoraproject.org> - 2.6.0-1
- version 2.6.0
- raise dependency on zend-eventmanager >= 2.6.2
- raise dependency on zend-stdlib >= 2.7

* Wed Jan 20 2016 Remi Collet <remi@fedoraproject.org> - 2.5.3-1
- version 2.5.3

* Thu Aug  6 2015 Remi Collet <remi@fedoraproject.org> - 2.5.2-1
- version 2.5.2

* Tue Aug  4 2015 Remi Collet <remi@fedoraproject.org> - 2.5.1-1
- initial package
